
class AllHumans
{
  float growthDistance = 100;
  int chanceSpawnType = 25; //25 percent (out of 100) chance that new humans will spawn randomly somewhere
                            //opposed to spawning as a branch off an old human node.
  int humanSpawnCounter = 0;
  int humanSpawnTime = 1700; //1800 should be level 1;  make this baseed on how many humans there are
                           //more humans, the higher teh spawn time (300 being the max).
  
  ArrayList humanList = new ArrayList();
  int type1Dmg = 1;
  int type2Dmg = 3;
  int type3Dmg = 9;
  BoundingCircle[] landCircles;
  PImage landImg;
  PImage greenHumanImg;
  PImage redHumanImg;
  PImage terrorHumanImg;
  PImage entgreenHumanImg;
  PImage entredHumanImg;
  PImage entterrorHumanImg;
  PImage infectedImg;
  float landMaxWeight = 0;
  
  public AllHumans()
  {
    greenHumanImg = loadImage("greenHuman.bmp");
    redHumanImg = loadImage("redHuman.bmp");
    terrorHumanImg = loadImage("terrorHuman.bmp");
    entgreenHumanImg = loadImage("EgreenHuman.bmp");
    entredHumanImg = loadImage("EredHuman.bmp");
    entterrorHumanImg = loadImage("EterrorHuman.bmp");
    infectedImg = loadImage("infected.png");
    landImg = loadImage("purpRad.png");
    landCircles = new BoundingCircle[15];
    
    landCircles[0] = new BoundingCircle(new PVector(-100,600,0), 900, true, 0); //australia
    
    landCircles[1] = new BoundingCircle(new PVector(2500,-1800,0), 1800, true, 1); //canada
    
    landCircles[2] = new BoundingCircle(new PVector(1900,-2050,0), 1100, true, 2); //alaska
    
    landCircles[3] = new BoundingCircle(new PVector(2950,-1150,0), 1800, true, 3); //USA
    
     landCircles[4] = new BoundingCircle(new PVector(3750,150,0), 1300, true, 4 ); //SouthAmN
     
     landCircles[5] = new BoundingCircle(new PVector(3800,650,0), 1000, true, 5); //SouthAmS
     
     landCircles[6] = new BoundingCircle(new PVector(5300,-500,0), 1450, true, 6); //NAfrica
     
     landCircles[7] = new BoundingCircle(new PVector(5850,-150,0), 1500, true, 7); //CAfrica
     
     landCircles[8] = new BoundingCircle(new PVector(5775, 400,0), 1050, true, 8); //SAfrica
     
     landCircles[9] = new BoundingCircle(new PVector(5375, -1290,0), 570, true, 9); //france
      
     landCircles[10] = new BoundingCircle(new PVector(5725,-1315,0), 900, true, 10); //CEur
       
     landCircles[11] = new BoundingCircle(new PVector(7300,-1500,0), 3750, true, 11); //Asia
       
     landCircles[12] = new BoundingCircle(new PVector(6185,-1600,0), 1680, true, 12); //EastEur
     
     landCircles[13] = new BoundingCircle(new PVector(8360,-2060,0), 1400, true, 13); //NEAsia
  
     landCircles[14] = new BoundingCircle(new PVector(8900, -2100,0), 920, true, 14); //NEAsia2

      //humanList.add(new Human (new PVector(1900,-2050,0), 2, 1));
     AssignWeights(landCircles);
     AssignNeighbours(landCircles);
  }
  
  void AssignWeights(BoundingCircle[] circleList)
  {
    landMaxWeight = 0;
    //first get the max weight
    for (int i = 0; i < circleList.length; i++)
        landMaxWeight += circleList[i].radius*2;
        
    //assign the circles a range of values, representing their 
    //weight within the list of circles based on radius
    for (int i = 0; i < circleList.length; i++)
    {
      if (i == 0)
      {
        circleList[i].weightMin = 0;
        circleList[i].weightMax = circleList[i].radius * 2;  
      }
      else
      {
        circleList[i].weightMin = circleList[i-1].weightMax;
        circleList[i].weightMax = circleList[i].weightMin + (circleList[i].radius * 2);  
      }
    }
  }
  void AssignNeighbours(BoundingCircle[] circleList)
  {
    for (int i = 0; i < circleList.length; i++)
    {
      for (int j = 0; j < circleList.length; j++)
      {
        //if (circleList[i].pos != circleList[j].pos)
        //{
          if (circleList[i].CircleCollision(circleList[j].pos, circleList[j].radius))
          {
          circleList[i].neighbourList.add(circleList[j]);
          
          //System.out.println("circle " + i + " has " + j + " as a neighbour");
          }
        //}
      }
    }
  }
  
  public void Update(long elapsedTime, ArrayList entangles, Camera3D cameraa, float worldWidth)
  {    
    humanSpawnCounter += elapsedTime;
    
    //Spawn More Humans
    if (humanSpawnCounter > humanSpawnTime)
    {
      humanSpawnCounter = 0;
      
      if (random(100) < chanceSpawnType)
      {
          float rhor = random(landMaxWeight);
          for (int i = 0; i < landCircles.length; i++)
          {
            if (rhor >= landCircles[i].weightMin && rhor < landCircles[i].weightMax)
            {
              float randDir = random(359);
              PVector spawnPos = new PVector(landCircles[i].pos.x + ((rhor - landCircles[i].weightMin) - landCircles[i].radius), landCircles[i].pos.y, 0);
              spawnPos = RotateVector(landCircles[i].pos, randDir, spawnPos);  
               
               if (!HumanOnEntangle(spawnPos, 25/2, entangles, cameraa, worldWidth))
                   humanList.add(new Human(spawnPos, i, (int)random(3) + 1));
              
              break;
            }
          }
      }
      else
      {
        if (humanList.size() > 0)
        {
         
          int randHum = (int)(random(humanList.size()));
          float randDir = random(359);
          
          PVector spawnPos = new PVector();
          spawnPos.set(((Human)humanList.get(randHum)).quadd.center);
          spawnPos.x -= growthDistance;
          
          spawnPos = RotateVector(((Human)humanList.get(randHum)).quadd.center, randDir, spawnPos);  
          Human newHuman = new Human(spawnPos, -1, ((Human)humanList.get(randHum)).type);
          if (newHuman.type == 1)
          {
            if ( (int)random(4) > 2)
            {
              newHuman.type = 2;
            }
          }
          newHuman.currentCircle = CheckNewHumanOnLandCollision(randHum, newHuman.pos );
          
          if (newHuman.currentCircle == -1) //if it is outside the circle, spawn it randomly within the circle
          {
           
            PVector moveVector =PVector.sub( landCircles[((Human)humanList.get(randHum)).currentCircle].pos, newHuman.quadd.center);
            moveVector.normalize();
            moveVector.mult((int)random( landCircles[((Human)humanList.get(randHum)).currentCircle].radius ) + growthDistance);
            
            newHuman.Move( moveVector );
            newHuman.currentCircle = ((Human)humanList.get(randHum)).currentCircle;
           // println("outside of circle");
          }
          
         // println("spawn new human off of human num = " + randHum + " on circleID = " + newHuman.currentCircle);
        if (!HumanOnEntangle(newHuman.quadd.center, newHuman.radius, entangles, cameraa, worldWidth))
          humanList.add(newHuman);
        }    
        
      }
     
    }
    
  }
  
  
  boolean HumanOnEntangle(PVector newHumanPos, float newHumanRadius, ArrayList entangles, Camera3D cameraa, float worldWidth)
  {
    if (entangles.size() >0)
    {
    for (int i = entangles.size() - 1; i >=0; i--)
    {
     if ( CircleCollisionNoOverlap(((BoundingCircle)entangles.get(i)).quadd.center, ((BoundingCircle)entangles.get(i)).radius, newHumanPos, newHumanRadius ))
      {
        return true;
      }
     else if (newHumanPos.x > cameraa.pos.x)
      {
        PVector virtualEntPos = new PVector();
        virtualEntPos.set(((BoundingCircle)entangles.get(i)).quadd.center);
        virtualEntPos.x += worldWidth;
        if ( CircleCollisionNoOverlap(virtualEntPos, ((BoundingCircle)entangles.get(i)).radius, newHumanPos, newHumanRadius ))
        {
          return true;
        }
      }
     else if (newHumanPos.x < cameraa.pos.x)
     {
       PVector virtualEntPos= new PVector();
       virtualEntPos.set(((BoundingCircle)entangles.get(i)).quadd.center);
        virtualEntPos.x -= worldWidth;
       if ( CircleCollisionNoOverlap(virtualEntPos, ((BoundingCircle)entangles.get(i)).radius, newHumanPos, newHumanRadius ))
        {
          return true;
        }
     }
    }
    
    }
    return false;
  }
  
  
// FOR DEBUGGING ONLY, will create problems otherwise
//  void CreateHumanAtPos(PVector ipos)
//  {
//    humanList.add(new Human(ipos, 0, 1));
//  }


  //check to see if the new human being spawned is going to be on land.
  int CheckNewHumanOnLandCollision(int humanNum, PVector newHumanPos)
  {
    for (int i = 0; i < landCircles[(((Human)humanList.get(humanNum)).currentCircle)].neighbourList.size(); i++)
    {
      if (((BoundingCircle)landCircles[(((Human)humanList.get(humanNum)).currentCircle)].neighbourList.get(i)).CircleCollision( newHumanPos, 
                                           ((Human)humanList.get(humanNum)).radius) )
       {
         
         return ((BoundingCircle)landCircles[(((Human)humanList.get(humanNum)).currentCircle)].neighbourList.get(i)).id;
       }
    }
    return -1;
  }
  
  
  public void Draw(float worldWidth, Camera3D cameraa)
  {
    //System.out.println("camera x y = " + cameraa.pos.x + " " + cameraa.pos.y);
    for (int i = 0; i < landCircles.length; i++)
    {
       if (!ShouldDraw(   landCircles[i].quadd.points[0].x, landCircles[i].quadd.points[2].x, cameraa))
       {
          float changeAmount = SetQuadX(cameraa, landCircles[i].quadd, worldWidth);
          if (changeAmount != 0) //if the quad was moved, also move all the humans that are on that circle.
          {
            for (int j = 0; j < humanList.size(); j++)
            {
              //System.out.println("humans currentcircle = " + ((Human)humanList.get(j)).currentCircle);
              
              if ( ((Human)humanList.get(j)).currentCircle == i)
              {
                ((Human)humanList.get(j)).MoveX(changeAmount);
              }
            }
          }
          landCircles[i].pos.set(landCircles[i].quadd.center);
       }
       else
       {
         //landCircles[i].Draw(landImg);//,  (float)worldMapImg.width/numOfCols * (i),    0,     (float)worldMapImg.width/numOfCols * (i+1),     (float)worldMapImg.height);
       }
       
    }
    
    //draw humans
    if (humanList.size() > 0)
    {
      for (int i = 0; i < humanList.size(); i++)
      {
        switch(((Human)humanList.get(i)).type)
        {
          case 1:
        ((Human)humanList.get(i)).Draw(greenHumanImg);
          break;
          case 2:
        ((Human)humanList.get(i)).Draw(redHumanImg);
          break;
          case 3:
        ((Human)humanList.get(i)).Draw(terrorHumanImg);
          break;
           case 4:
        ((Human)humanList.get(i)).Draw(entgreenHumanImg);
          break;
          case 5:
        ((Human)humanList.get(i)).Draw(entredHumanImg);
          break;
          case 6:
        ((Human)humanList.get(i)).Draw(entterrorHumanImg);
          break;
          default:
          ((Human)humanList.get(i)).Draw(terrorHumanImg);
          break;
        }
        if (((Human)humanList.get(i)).infected > -1)
            ((Human)humanList.get(i)).Draw(infectedImg);
      }
    }
  }
  
  
  //returns the amount that was translated
  float SetQuadX(Camera3D cameraa, Quad2D iQuad, float worldWidth)
  {
    if (cameraa.pos.x < iQuad.center.x)
    {  
      if (Math.abs(iQuad.center.x - cameraa.pos.x) > (worldWidth - Math.abs(iQuad.center.x - cameraa.pos.x)))
      {
             TranslateQuadX(iQuad, -worldWidth);
             return -worldWidth;
      }
    }
    else 
    { 
      if (Math.abs(cameraa.pos.x - iQuad.center.x) > (worldWidth - Math.abs(cameraa.pos.x - iQuad.center.x)))
      {
              TranslateQuadX(iQuad, worldWidth);
              return worldWidth;
      }
    }
    return 0;
  }
  void TranslateQuadX(Quad2D iQuad, float changeX)
  {
     iQuad.points[0].x += changeX;
     iQuad.points[1].x += changeX;
     iQuad.points[2].x += changeX;
     iQuad.points[3].x += changeX;
     
     iQuad.center.x += changeX;
  }
   void TranslatePointX(PVector ivec, float changeX)
  {
     ivec.x += changeX;
  }
  
  boolean ShouldDraw(float minA, float maxA, Camera3D cameraa)
  {
    if (cameraa.pos.x- (cameraa.cwidth) > maxA)
        return false;
      if (minA > cameraa.pos.x + (cameraa.cwidth))
        return false;
       
       return true;
  }
  
  PVector  RotateVector(PVector rotAxis, float rotAmount, PVector rotVec)
  {
    PVector rotateVec = new PVector();
    rotateVec.set(rotVec);
    rotateVec.sub(rotAxis);
    PVector returnVec = new PVector();
    
    returnVec.x = (rotateVec.x *(cos(rotAmount))) - (rotateVec.y *(sin(rotAmount)));
    returnVec.y = (rotateVec.x *(sin(rotAmount))) + (rotateVec.y *(cos(rotAmount)));
    returnVec.add(rotAxis);
    return returnVec;
  }
  
  boolean CircleCollisionNoOverlap(PVector aPos, float aRadius, PVector bPos, float bRadius)
  {
    if ((PVector.sub(aPos, bPos)).mag() < (aRadius + bRadius))
      return true;
    else
      return false;
  }
  
 
  
}
