//import java.awt.AWTException; 
//import java.awt.Robot; 
//import java.awt.event.KeyEvent;
//import java.awt.Frame;

class Play extends GameState
{
  int clockTime = 0;
  
  int levelUpInterval = 40000;
  int nextLevelUp = levelUpInterval;
  
  ArrayList effects = new ArrayList(); 
  
  Quad2D crosshair;
  PImage crosshairImg;
  
  GUI gui;
  boolean drawWorld = true;
  float mouseInputThreshold = 1;
  float speedMult = 0.1; //0.05 is perfect
    
  World earth;
    
  int centerPosX, centerPosY; //where the mouse needs to reset to.
  boolean mouseLocked = true;
  Camera3D cameraa;
  Player p1; 
  
  
  Play()
  {
    
    earth = new World();
    cameraa = new Camera3D(new PVector(earth.worldWidth/2,0,0));
    earth.star.cameraa = cameraa;
    p1 = new Player(new PVector(earth.worldWidth/2, 0, 0), 32, 32);
    
    crosshairImg = loadImage("crosshair.png");
    crosshair = new Quad2D(cameraa.pos, 32, 32);
    
    gui = new GUI(cameraa, earth, p1);
    //ResetMouse();
    
   // println( -360%170);
   
  }
  
  int TakeInput(long elapsedTime)
  {
    if(keyPressed)
    { 
      switch(key)
      {
        case '1':
        p1.activeA = 1;
        break;
        case '5':
        p1.activeA = 2;        
        break;
        case '3':
        p1.activeA = 3;    
        break;
        case '4':
        p1.activeA = 4;        
        break;
        case '2':
        p1.activeA = 5;      
        break;
        
      }
      //check to see if the player changes the game state (ie. pushes q to quit)
    }

  
    return -1;
  }
  
  void LevelUp()
  {
    if (clockTime > nextLevelUp)
    {
      nextLevelUp += levelUpInterval;
      earth.level ++;
      earth.levelUpDisplayTimeCounter = earth.levelUpDisplayTime;
      
      earth.humans.humanSpawnTime -= 60;
      if (earth.humans.humanSpawnTime < 140)
      {
        earth.humans.humanSpawnTime = 140;
        
      }
    }
  }
  
  int Update(long elapsedTime)
  { 
    if (effects.size() > 0)
    {
    for (int i = effects.size() - 1; i >=0; i--)
    {
      boolean destroy = ((Effect)effects.get(i)).Update(elapsedTime);
      if (destroy == true)
      {
        effects.remove(i);
      }
    }
    }
    

          if (p1.planetHealth <=0)
          {
            return 2;
          }

      clockTime += elapsedTime;
      LevelUp();
      int stateID = TakeInput(elapsedTime); //if stateID != -1, then change to the correct state.
      
      //TAKE MOUSE INPUT AND MOVE THE CAMERA
      
      p1.mouseInput = new PVector((((float)mouseX + 3) - (float)width/2), 
                                  (((float)mouseY + 25) - (float)height/2), 0); //the +3 and + 25 are something fucked, but it makes it work
      
      crosshair.MoveTo(new PVector(cameraa.pos.x - cameraa.cwidth + mouseX*2 , cameraa.pos.y - cameraa.cheight + mouseY*2 , 0));
      
      float mSpeed = p1.mouseInput.mag();
      mSpeed -= mouseInputThreshold;
      if (mSpeed < 0)
        mSpeed = 0; //create the threshold for mouse input based on mouseInputThreshold
      
      
      PVector mInput = new PVector();
      mInput.set( p1.mouseInput ); //set to mouseInput because operating directly on p1.mouseInput will fuck it all up.

      mInput.normalize();
      mInput.mult(mSpeed);
     
      //p1.velocity = PVector.mult(mInput, 0.05 * ( (float)elapsedTime / 17  ) );
      p1.velocity = PVector.mult(mInput, speedMult);
      if (p1.velocity.mag() > p1.maxVel)
      {
        p1.velocity.normalize();
        p1.velocity.mult(p1.maxVel);
      }
      p1.pos.add(p1.velocity);
    //Translate camera;
   // cameraa.pos.add(  PVector.sub(p1.pos, cameraa.pos) ); //0.05
     cameraa.pos.add(  p1.velocity ); //0.05

      //keep the camera within some up and down boundaries.
     if (cameraa.pos.y - cameraa.cheight < earth.worldMapQuads[0].points[0].y)
     {
       cameraa.pos.y -= (cameraa.pos.y - cameraa.cheight) - earth.worldMapQuads[0].points[0].y;
       p1.pos.y -= (cameraa.pos.y - cameraa.cheight) - earth.worldMapQuads[0].points[0].y;
     }
     else if (cameraa.pos.y + cameraa.cheight > earth.worldMapQuads[0].points[2].y)
     {
       cameraa.pos.y -= (cameraa.pos.y + cameraa.cheight) - earth.worldMapQuads[0].points[2].y;
       p1.pos.y -= (cameraa.pos.y + cameraa.cheight) -earth.worldMapQuads[0].points[2].y;
     }
     
     ProcessAbilityReady();
     ProcessMouseClicks();
     
     ProcessEntangle(elapsedTime);
     ProcessSaucers();
     ProcessVirus();
     
     ProcessNature();
     ProcessRage();
     
     earth.Update(elapsedTime, cameraa);

     return -1;
  }
  
  void ProcessAbilityReady()
  {
    if (clockTime > p1.nextSmiteInterval && p1.nature >= p1.smiteNatureCost)
    {
      p1.smiteReady = true;
    }
    else
      p1.smiteReady = false;
      
    if (clockTime > p1.nextFingInterval && p1.ether >= p1.fingEtherCost && p1.rage >= p1.fingRageCost)
    {
      p1.fingReady = true;
    }
    else
      p1.fingReady = false;
      
    if (clockTime > p1.nextEntInterval && p1.nature >= p1.entNatureCost)
    {
      p1.entReady = true;
    }
    else
      p1.entReady = false;
      
    if (clockTime > p1.nextSaucerInterval && p1.ether >= p1.saucerEtherCost && p1.luck >= p1.saucerLuckCost)
    {
      p1.saucerReady = true;
    }
    else
      p1.saucerReady = false;
      
    if (clockTime > p1.nextVirusInterval && p1.nature >= p1.virusNatureCost && p1.rage >= p1.virusRageCost)
    {
      p1.virusReady = true;
    }
    else
      p1.virusReady = false;
  }

  boolean testDraw = false;
  void ProcessMouseClicks()
  {
    if (right)
    {
     
    }
    if (left)
    {
      testDraw = true;
      switch(p1.activeA)
      {
        case 1: //smite
          Smite();
        break;
        
        case 2: //finger of god
          FingerOfGod();
        break;
        
        case 3: //entangle
          Entangle();
        break;
        
        case 4: //saucer
          Saucer();
        break;
        
        case 5: //virus
          Virus();
        break;
      }
    }
    else
      testDraw = false;
  }
  
void ProcessEntangle(long elapsedTime)
{
  if (earth.entangles.size() > 0)
  {
    for (int i = earth.entangles.size() - 1; i >=0; i--)
    {
      ((BoundingCircle)earth.entangles.get(i)).lifeTime -= elapsedTime;
      if (((BoundingCircle)earth.entangles.get(i)).lifeTime <=0)
      {
        for (int j = earth.humans.humanList.size() - 1; j >= 0; j--)
          {
              if ( ((Human)earth.humans.humanList.get(j)).type ==4)
                  ((Human)earth.humans.humanList.get(j)).type =1;
              else if ( ((Human)earth.humans.humanList.get(j)).type ==5)
                  ((Human)earth.humans.humanList.get(j)).type =2;
              else if ( ((Human)earth.humans.humanList.get(j)).type ==6)
                  ((Human)earth.humans.humanList.get(j)).type =3;

          }
        earth.entangles.remove(i);
      }
    }
  }
}

void ProcessSaucers()
{
  if (earth.saucers.size() > 0)
  {
  for (int i = earth.saucers.size() - 1; i >=0; i--)
    {
        for (int j = earth.humans.humanList.size() - 1; j >= 0; j--)
          {
            if ( CircleCollisionNoOverlap( ((Saucer)earth.saucers.get(i)).quadd.center, ((Saucer)earth.saucers.get(i)).attackRadius, ((Human)earth.humans.humanList.get(j)).quadd.center, ((Human)earth.humans.humanList.get(j)).radius))
            {
               KillHuman(j);
              ((Saucer)earth.saucers.get(i)).kills ++;
            }
              
          }
    }
  }
}

void ProcessVirus()
{
  //println("p1.virus exists " + p1.virusExist);
  if (p1.virusExist)
  {
    if (clockTime > p1.nextVirusProcess)
    {
      p1.nextVirusProcess = clockTime + p1.processVirusTime;
      p1.virusExist = false;
      for (int i = earth.humans.humanList.size() - 1; i >= 0; i--)
      {
          if (((Human)earth.humans.humanList.get(i)).infected > -1 && ((Human)earth.humans.humanList.get(i)).infected < clockTime )
          {
            for (int j = earth.humans.humanList.size() - 1; j >= 0; j--)
            {
              if ( CircleCollisionNoOverlap( ((Human)earth.humans.humanList.get(i)).quadd.center, p1.virusInfectRange, ((Human)earth.humans.humanList.get(j)).quadd.center, 25/2   ) )
              {
                if ( ((Human)earth.humans.humanList.get(j)).infected == -1)
                  ((Human)earth.humans.humanList.get(j)).infected = clockTime;
                
                p1.virusExist = true;
              }
            }
            KillHuman(i);
          }
    
      }
    }
  }
}


// System.out.println("but am getting here " + clockTime + " crosshair x y = " + crosshair.center.x + " " + crosshair.center.y);
         //System.out.println("BE4 COLL human num: " + i + " at pos x y " + ((Human)earth.humans.humanList.get(i)).pos.x + " " + ((Human)earth.humans.humanList.get(i)).pos.y +" at circle: " + ((Human)earth.humans.humanList.get(i)).currentCircle );
         
           //System.out.println("COLL human num: " + i + " at pos x y " + ((Human)earth.humans.humanList.get(i)).pos.x + " " + ((Human)earth.humans.humanList.get(i)).pos.y +" at circle: " + ((Human)earth.humans.humanList.get(i)).currentCircle );
           
           
  void Smite()
  {
    if (p1.smiteReady)
    {
      if (p1.nature >= p1.smiteNatureCost)
      {
        effects.add(new Effect(1, crosshair.center));
        p1.smiteReady = false;
        
        p1.nextSmiteInterval = clockTime + p1.smiteInterval;
        p1.nature -= p1.smiteNatureCost;
        
        
        if (earth.humans.humanList.size() > 0 )
        {
          for (int i = earth.humans.humanList.size() - 1; i >= 0; i--)
          {
           if ( CircleCollisionNoOverlap(crosshair.center, p1.smiteRadius, ((Human)earth.humans.humanList.get(i)).quadd.center, ((Human)earth.humans.humanList.get(i)).radius) )
               KillHuman(i);
          }
        }
        
      }
    }
  }

  

  void FingerOfGod()
  {
    if (p1.fingReady)
    {
      if (p1.ether >= p1.fingEtherCost && p1.rage >= p1.fingRageCost)
      {
        effects.add(new Effect(2, crosshair.center));
        p1.nextFingInterval = clockTime + p1.fingInterval;
        p1.ether -= p1.fingEtherCost;
        p1.rage -=p1.fingRageCost;
        p1.fingReady = false;
        
        if (earth.humans.humanList.size() > 0 )
        {
          for (int i = earth.humans.humanList.size() - 1; i >= 0; i--)
          {
           if ( CircleCollisionNoOverlap(crosshair.center, p1.fingRadius, ((Human)earth.humans.humanList.get(i)).quadd.center, ((Human)earth.humans.humanList.get(i)).radius) )
               KillHuman(i);
          }
        }
        
      }
    }
  }
  
  
  
  void Entangle()
  {
    if (p1.entReady)
    {
      if (p1.nature >= p1.entNatureCost)
      {
        p1.entReady = false;
        
        p1.nextEntInterval = clockTime + p1.entInterval;
        p1.nature -= p1.entNatureCost;
        
        earth.entangles.add(new BoundingCircle(crosshair.center, p1.entRadius*4, false, 0));
        ((BoundingCircle)earth.entangles.get(earth.entangles.size()-1)).lifeTime = p1.entLifeTime;
        
        //if the entangle collides with a star, create an ETHER.
        if ( CircleCollisionNoOverlap( earth.star.quadd.center, (earth.star.sizee/2), crosshair.center, p1.entRadius  ) )
        {
          if (earth.star.active)
            earth.star.GoToEtherMode();
        }
        
        //println("earth.entangles.size() " + earth.entangles.size());
        if (earth.humans.humanList.size() > 0 )
        {
          for (int i = earth.humans.humanList.size() - 1; i >= 0; i--)
          {
           if ( CircleCollisionNoOverlap(crosshair.center, p1.entRadius, ((Human)earth.humans.humanList.get(i)).quadd.center, ((Human)earth.humans.humanList.get(i)).radius) )
           { 
             if (((Human)earth.humans.humanList.get(i)).type == 1)  
               ((Human)earth.humans.humanList.get(i)).type = 4;
             else if (((Human)earth.humans.humanList.get(i)).type == 2)  
               ((Human)earth.humans.humanList.get(i)).type = 5;
             else if (((Human)earth.humans.humanList.get(i)).type == 3)  
               ((Human)earth.humans.humanList.get(i)).type = 6;
           }
          }
        }
        
      }
    }
  }
  
  
  
  void Saucer()
  {
    if (p1.saucerReady)
    {
      if (p1.luck >= p1.saucerLuckCost && p1.ether >= p1.saucerEtherCost)
      {
        p1.saucerReady = false;
        
        p1.nextSaucerInterval = clockTime + p1.saucerInterval;
        p1.luck -= p1.saucerLuckCost;
        p1.ether -= p1.saucerEtherCost;
        
        earth.saucers.add(new Saucer(crosshair.center, p1.saucerRadius));

      }
    }
  }
  
  
  
  void Virus()
  {
    if (p1.virusReady)
    {
      if (p1.rage >= p1.virusRageCost && p1.nature >= p1.virusNatureCost)
      {
        p1.virusReady = false;
        
        p1.nextVirusInterval = clockTime + p1.virusInterval;
        p1.rage -= p1.virusRageCost;
        p1.nature -= p1.virusNatureCost;
        
        for (int i = earth.humans.humanList.size() - 1; i >= 0; i--)
          {
           if ( CircleCollisionNoOverlap(crosshair.center, p1.virusRadius, ((Human)earth.humans.humanList.get(i)).quadd.center, ((Human)earth.humans.humanList.get(i)).radius) )
           { 
             ((Human)earth.humans.humanList.get(i)).infected = clockTime;
             p1.virusExist = true;
             
             p1.nextVirusProcess = clockTime + p1.processVirusTime;
           }
          }

      }
    }
  }

  void KillHuman(int humanNum)
  {
    earth.humans.humanList.remove(humanNum);
    p1.rage +=1;
  }
  
  void ProcessNature()
  {
    if (clockTime > p1.nextNatureInterval)
    {
        p1.nextNatureInterval += p1.processNatureInterval;
        p1.natureDiff = 0;
        
        if (earth.humans.humanList.size() > 0)
        {
            
            for (int i = 0; i < earth.humans.humanList.size(); i++)
            {
              switch (((Human)earth.humans.humanList.get(i)).type)
              {
                case 1:
                p1.natureDiff -= earth.humans.type1Dmg;
                break;
                case 2:
                p1.natureDiff -= earth.humans.type2Dmg;
                break;
                case 3:
                p1.natureDiff -= earth.humans.type3Dmg;
                break;
              }
            }
            
        }
        p1.natureDiff = (int)(p1.natureDiff * 0.5);
        p1.natureDiff += 100;

        //for balancing purposes
        if (p1.natureDiff < 0)
        {
          println("naturediff before = "+ p1.natureDiff);
          p1.natureDiff *= 0.25;
          println("naturediff after = "+ p1.natureDiff);
        }
        
        p1.nature += p1.natureDiff;
        if (p1.nature > 1000)
          p1.nature = 1000;
        else if (p1.nature < 0)
        p1.nature = 0;
        
      if (p1.nature <= 0)
      {
          p1.planetHealth -=5;
      }
      
    }
  }
  
  void ProcessRage()
  {
    if (clockTime > p1.nextRageInterval)
    {
      p1.nextRageInterval += p1.processRageInterval;
      
      p1.rage -= p1.rageLossPerInterval;
      if (p1.rage < 0)
        p1.rage = 0;
      else if (p1.rage > 100)
       p1.rage = 100;
    }
  }
  
  void ProcessStar()
  {
    if (right)
    {
    if (CircleCollisionNoOverlap( crosshair.center, 20, earth.star.quadd.center, (earth.star.sizee/2)))
    {
      if (earth.star.active)
      {
        if (earth.star.etherMode)
        {
          earth.star.GoToStarMode();
          p1.ether +=1;
        }
        else
          p1.luck += 1;
          
          earth.star.active = false;
      }
    }
    }
  }
  
  boolean CircleCollisionNoOverlap(PVector aPos, float aRadius, PVector bPos, float bRadius)
  {
    if ((PVector.sub(aPos, bPos)).mag() < (aRadius + bRadius))
      return true;
    else
      return false;
  }
  
  PVector CircleCollision(PVector aPos, float aRadius, PVector bPos, float bRadius)
  {
    if ((PVector.sub(aPos, bPos)).mag() < (aRadius + bRadius))
    {
      PVector distance = (PVector.sub(aPos, bPos));

      float overlap = (aRadius + bRadius) - distance.mag();

      distance.normalize();
      if (distance.mag() ==0)
        distance.x = 0.1;

      return PVector.mult(distance, overlap);

    }
    else
      return new PVector(0,0,0);
  }

  
  
  void Draw(long elapsedTime)
  {    
    //noCursor(); //hides the cursor

      background(0); //background colour

    ortho( - cameraa.cwidth , 
    cameraa.cwidth , 
    - cameraa.cheight, 
    cameraa.cheight , -100, 100);

    camera(cameraa.pos.x, cameraa.pos.y, 10, // eyeX, eyeY, eyeZ
    cameraa.pos.x, cameraa.pos.y, 0.0, // lookX, lookY, lookZ
    0.0, 1.0, 0.0); // upX, upY, upZ

    earth.Draw(elapsedTime, cameraa, drawWorld);
    
    for (int i = effects.size()-1; i >= 0; i--)
    {
      ((Effect)effects.get(i)).Draw();
    }
    
    p1.Draw(crosshair.center);
    
    crosshair.Draw(crosshairImg);
    
    gui.Draw(elapsedTime); 
//    if (testDraw == true)
//    gui.Testdraw();
  }


  void PrintVector(PVector vec)
  {
    System.out.println("vec x y z: " + vec.x + " " + vec.y + " " + vec.z  );
  }
  



boolean left=false;
boolean right=false;
boolean center=false;
void mousePressed()
{
  if(mouseButton==LEFT)
    left=true;
  if(mouseButton==RIGHT)
    right=true;
  if(mouseButton==CENTER)
    center=true;
}

void mouseReleased()
{
  ProcessStar();
  
  if(mouseButton==LEFT)
    left=false;
  if(mouseButton==RIGHT)
    right=false;
  if(mouseButton==CENTER)
    center=false;
    
  
} 


}













