class Player extends Entity
{
  int planetHealth = 100;

  int nature = 1000;
  int rage = 25; //25 good
  int luck = 2;
  int ether = 3;
  
  int processNatureInterval = 1000;
  int nextNatureInterval = processNatureInterval;
  
  int processRageInterval = 1000;
  int nextRageInterval = processRageInterval;
  int rageLossPerInterval = 1;
  
  //stuff for smite
  boolean smiteReady = true;
  int smiteInterval = 850;
  int nextSmiteInterval = 0;
  float smiteRadius = 50;
  Quad2D smiteRadiusQ;
  PImage smiteRadiusImg;
  
  int smiteNatureCost = 20;
  
  //stuff for finger of god
  boolean fingReady = true;
  int fingInterval = 6000; // 10 000
  int nextFingInterval = 0;
  float fingRadius = 550;
  Quad2D fingRadiusQ;
  PImage fingRadiusImg;
  
  int fingEtherCost = 1; //1
  int fingRageCost = 20; //20
  
  //stuff for entangle
  boolean entReady = true;
  int entInterval = 15000;
  int nextEntInterval = 0;
  float entRadius = 300;
  Quad2D entRadiusQ;
  PImage entRadiusImg;
  
  int entNatureCost = 75;
  int entLifeTime = 13000;
    
  //stuff for flying saucer
  boolean saucerReady = true;
  int saucerInterval = 10000;// 10 is perfect
  int nextSaucerInterval = 0;
  float saucerRadius = 75;
  Quad2D saucerRadiusQ;
  PImage saucerRadiusImg;
  
  int saucerLuckCost = 1;
  int saucerEtherCost = 1;
  
  //stuff for virus
  boolean virusReady = true;
  int virusInterval = 4000; //10
  int nextVirusInterval = 0;
  float virusRadius = 75;
  Quad2D virusRadiusQ;
  PImage virusRadiusImg;
   
  int virusRageCost = 10; //20
  int virusNatureCost = 10; //50
  
  int processVirusTime = 1250;
  int nextVirusProcess = 0; //next time virus will be processed
  int virusInfectRange = 160;
  boolean virusExist = false;
  
  int natureDiff = 0;
  
  int  activeA = 1; 
  boolean dirLeft = true;

  PVector velocity = new PVector(0,0,0);
  float maxVel = 50; //25 is perfect

  PVector mouseInput = new PVector(0,0,0); //used to store the current mouse input
  PVector prevMouseInput = new PVector(0,0,0);

  PVector down = new PVector(0,0,0);


  PImage img;

  float radius; 


  Player(PVector iPos, float iWidth, float iHeight)
  {
    radius = iHeight/2;      
    pos = iPos;

  //stuff for smite
  smiteRadiusQ = new Quad2D(new PVector(0,0,0), smiteRadius*2, smiteRadius*2);
  smiteRadiusImg = loadImage("yel10Rad.png");
  
  //stuff for finger of god
  fingRadiusQ = new Quad2D(new PVector(0,0,0), fingRadius*2, fingRadius*2);
  fingRadiusImg = loadImage("purpRad.png");
  
  //stuff for entangle
  entRadiusQ = new Quad2D(new PVector(0,0,0), entRadius*2, entRadius*2);
  entRadiusImg = loadImage("greRad.png");
  
  //stuff for flying saucer
  saucerRadiusQ = new Quad2D(new PVector(0,0,0), saucerRadius*2, saucerRadius*2);
  saucerRadiusImg = loadImage("yelRad.png");

  //stuff for virus
  virusRadiusQ = new Quad2D(new PVector(0,0,0), virusRadius*2, virusRadius*2);
  virusRadiusImg = loadImage("redRad.png");
  }

  //  void Move(int hor, int ver)
  //  {
  //    
  //    pos = new PVector(hor, ver, pos.z);
  //    quadd.Translate(new PVector(hor, ver, 0));
  //    swordQuad.Translate(new PVector(hor, ver, 0));
  //  }

  void Update()
  {
  }

  void Translate(PVector iVelocity)
  {
    //iVelocity.mult(0.15);

    pos.add(iVelocity);

  }

  float FindAngle2D(PVector v1, PVector v2)
  {
    //float angle = -(180/PI)*atan2(v1.x*v2.y - v1.y*v2.x, v1.x*v2.x+v1.y*v2.y);
    float angle = -atan2(v1.x*v2.y - v1.y*v2.x, v1.x*v2.x+v1.y*v2.y);

    return angle;
  }

  PVector ReturnNormal(PVector v1, boolean clockwise)
  {
    PVector normalV1 = new PVector();
    normalV1.set(v1);

    if (clockwise)
    {
      float y = normalV1.y;
      normalV1.y = -normalV1.x;
      normalV1.x = y;
    }
    else
    {
      float y = normalV1.y;
      normalV1.y = normalV1.x;
      normalV1.x = -y;
    }

    return normalV1;
  }

  
   PVector  RotateVector(PVector rotAxis, float rotAmount, PVector rotVec)
  {
    PVector rotateVec = new PVector();
    rotateVec.set(rotVec);
    rotateVec.sub(rotAxis);
    PVector returnVec = new PVector();
    
    returnVec.x = (rotateVec.x *(cos(rotAmount))) - (rotateVec.y *(sin(rotAmount)));
    returnVec.y = (rotateVec.x *(sin(rotAmount))) + (rotateVec.y *(cos(rotAmount)));
    returnVec.add(rotAxis);
    return returnVec;
  }
  
   PVector MirrorVector2D(PVector v1, PVector axisA, PVector axisB)
  {
    PVector axis = PVector.sub(axisA, axisB);
    
    PVector axisNormal = ReturnNormal(axis, true);
    
    PVector mirrorVec = new PVector();
    
    mirrorVec.set(v1);
    mirrorVec.sub(axisB);
    mirrorVec = PVector.sub(mirrorVec, PVector.div( PVector.mult( axisNormal, 2*mirrorVec.dot(axisNormal) ), pow(axisNormal.mag(),2))     );
    mirrorVec.add(axisB);
      
     return mirrorVec;
  }
  
  void Draw(PVector crosshair)
  {
    switch(activeA)
    {
      case 1:
      if (smiteReady){
      smiteRadiusQ.MoveTo(crosshair);
      smiteRadiusQ.Draw(smiteRadiusImg);
      }
      break;
      case 2:
      if (fingReady){
      fingRadiusQ.MoveTo(crosshair);
      fingRadiusQ.Draw(fingRadiusImg);
      }
      break;
      case 3:
      if (entReady){
      entRadiusQ.MoveTo(crosshair);
      entRadiusQ.Draw(entRadiusImg);
      }
      break;
      case 4:
      if (saucerReady){
      saucerRadiusQ.MoveTo(crosshair);
      saucerRadiusQ.Draw(saucerRadiusImg);
      }
      break;
      case 5:
      if (virusReady){
      virusRadiusQ.MoveTo(crosshair);
      virusRadiusQ.Draw(virusRadiusImg);
      }
      break;
    }
  }

  
}



