
class Star
{
  Camera3D cameraa;
  float worldWidth;
  float worldHeight;
  Quad2D quadd;
  PImage img;
  PImage etherImg;
  
  PVector vel;
  float speed = 10;
  int sizee = 130;
  int spawnTimeCounter = 0;
  int spawnTime = 10000;
  int spawnTimeMin = 10000;
  int spawnTimeMax = 25000;
  int aliveTime = 0; //counter for how long the star is live.
  int maxAliveTime = 9000;
  
  int timeInEther = 0;
  int maxTimeInEther = 10000;
  
  
  boolean active = false;
  boolean etherMode = false;
  
  Star(float iworldHeight, float iworldWidth)
  { 
    img = loadImage("shootingstar.png");
    etherImg = loadImage("ether.png");
    
    worldWidth = iworldHeight;
    worldHeight =  iworldWidth;
    
    spawnTime = (int)random(spawnTimeMax-spawnTimeMin) + spawnTimeMin;
    
    quadd = new Quad2D(new PVector(0,  0, 0), sizee, sizee);
    vel = new PVector(0,0,0);
  }
  
  void Update(long elapsedTime)
  {  
    if (!etherMode)
   { 
        spawnTimeCounter += elapsedTime;
        if(spawnTimeCounter > spawnTime)
        {
          spawnTimeCounter = 0;
          spawnTime = (int)random(spawnTimeMax-spawnTimeMin) + spawnTimeMin;
          active = true;
          aliveTime = 0;
          
          
          float spawnX = cameraa.pos.x + (int)random(cameraa.cwidth) - cameraa.cwidth/2;
          
          float spawnY = (int)random(2);
          if (spawnY == 0)
          {
            spawnY = cameraa.pos.y + cameraa.cheight + 100;
            vel.y = -100;
          }
          else
          {
            spawnY = cameraa.pos.y - cameraa.cheight - 100;
            vel.y = 100;
          }
            
          quadd = new Quad2D(new PVector(spawnX,  spawnY, 0), sizee, sizee);
          
          vel.x = (int)random(50);
          if (spawnX > cameraa.pos.x)
            vel.x *= -1;
            
          vel.normalize();
          vel.mult(speed);
          
          quadd = quadd.RotateQuad(quadd.center, FindAngle2D(vel, new PVector(0,1,0)));
        }
        
        if (active)
        {
          aliveTime += elapsedTime;
          if (aliveTime > maxAliveTime)
          {
            active = false;  vel.x = 0; vel.y = 0;
          }
          quadd.Translate(vel);
        }
    
   }
   else
   {
     timeInEther += elapsedTime;
     if (timeInEther > maxTimeInEther)
       GoToStarMode();
       
     quadd.Translate(vel);
   }
  }
  
  
  void GoToStarMode()
  {
    speed = 10;
    etherMode = false;
    active = false;
  }
  
  void GoToEtherMode()
  {
    speed = 1.5;
    etherMode = true;
    vel.normalize();
    vel.mult(speed);
    timeInEther = 0;
  }
  
  PVector  RotateVector(PVector rotAxis, float rotAmount, PVector rotVec)
  {
    PVector rotateVec = new PVector();
    rotateVec.set(rotVec);
    rotateVec.sub(rotAxis);
    PVector returnVec = new PVector();
    
    returnVec.x = (rotateVec.x *(cos(rotAmount))) - (rotateVec.y *(sin(rotAmount)));
    returnVec.y = (rotateVec.x *(sin(rotAmount))) + (rotateVec.y *(cos(rotAmount)));
    returnVec.add(rotAxis);
    return returnVec;
  }
  
  void Draw()
  {
    if (etherMode == false)
    {
    if (active)
    quadd.Draw(img);
    }
    else
    quadd.Draw(etherImg);

  }
  
  float FindAngle2D(PVector v1, PVector v2)
  {
    //float angle = -(180/PI)*atan2(v1.x*v2.y - v1.y*v2.x, v1.x*v2.x+v1.y*v2.y);
    float angle = -atan2(v1.x*v2.y - v1.y*v2.x, v1.x*v2.x+v1.y*v2.y);

    return angle;
  }
}
