//import java.awt.AWTException; 
//import java.awt.Robot; 
//import java.awt.event.KeyEvent;
//import java.awt.Frame;

class World
{
    int  level = 1;
    int levelUpDisplayTime = 5500;
    int levelUpDisplayTimeCounter = levelUpDisplayTime;
    int levelUpDisplayFadeTime = 2000;
    
    int wildLife = 1000;
    int maxWildLife = 1000;
    
    AllHumans humans;
    
    PImage worldMapImg = loadImage("WorldMap.jpg");
    
    PImage saucerImg = loadImage("saucer.png");
    ArrayList saucers = new ArrayList();
    
    PImage entangled = loadImage("entangled.png");
    ArrayList entangles = new ArrayList();
    
    int numOfCols = 10;
    float colWidth = 0;
    Quad2D[] worldMapQuads;
    Quad2D worldMapQuad;
    float worldWidth = (float)worldMapImg.width*2.5f;
    float worldHeight = (float)worldMapImg.height*2.5f;
    Star star;
    
  World()
  {        
    humans = new AllHumans();
    
     worldMapQuad = new Quad2D(new PVector(0, 0, 0), worldWidth, worldHeight);
     worldMapQuads = new Quad2D[numOfCols];
     
     
     colWidth = worldWidth/numOfCols;
     
     for (int i = 0; i < worldMapQuads.length; i++)
     {
       worldMapQuads[i] = new Quad2D(new PVector( (colWidth* i)  ,0,0), colWidth , worldHeight );
     }
     
     star = new Star(worldHeight, worldWidth);
  }

  
  void Update(long elapsedTime, Camera3D cameraa)
  { 
      humans.Update(elapsedTime, entangles, cameraa, worldWidth);
      
      //set all humans issomeonesclosest to false
//      for (int i = 0; i < humans.humanList.size(); i++)
//      {
//        ((Human)humans.humanList.get(i)).isSomeonesClosest = false;
//      }
      for (int i = 0; i < saucers.size(); i++)
      {
        ((Saucer)saucers.get(i)).Update(elapsedTime, worldHeight, humans.humanList);
      }
     star.Update(elapsedTime);
  }

  void Draw(long elapsedTime, Camera3D cameraa, boolean drawWorld)
  {    
     
     DrawWorldCols(cameraa, drawWorld);
     
     humans.Draw(worldWidth, cameraa);
     
    DrawEntangles(cameraa);
    DrawSaucers(cameraa);
      
     DrawStar(cameraa); 
    
  }


  void DrawWorldCols(Camera3D cameraa, boolean drawWorld)
  {
    for (int i = 0; i < worldMapQuads.length; i++)
     {
       //only draw the column of the Earth if it is infront of the camera
       if (!ShouldDraw(   worldMapQuads[i].points[0].x, worldMapQuads[i].points[2].x, cameraa))
       {
        SetQuadX(cameraa, worldMapQuads[i]);
           //   TranslateQuadX(worldMapQuads[i], worldWidth );
              
       // if (ShouldDraw(  worldMapQuads[i].points[0].x, worldMapQuads[i].points[2].x, cameraa))
         //{
           //  worldMapQuads[i].Draw(worldMapImg,  (float)worldMapImg.width/numOfCols * (i),    0,     (float)worldMapImg.width/numOfCols * (i+1),     (float)worldMapImg.height);
         //}  
       }
       else
       {
         if (drawWorld)
           worldMapQuads[i].Draw(worldMapImg,  (float)worldMapImg.width/numOfCols * (i),    0,     (float)worldMapImg.width/numOfCols * (i+1),     (float)worldMapImg.height);
       }
     }
  }
  
  void DrawEntangles(Camera3D cameraa)
  {
    if (entangles.size() > 0)
    {
    for(int i = 0; i < entangles.size(); i++)
    {
      if (!ShouldDraw(((BoundingCircle)entangles.get(i)).quadd.points[0].x, ((BoundingCircle)entangles.get(i)).quadd.points[2].x, cameraa))
      {
        SetQuadX(cameraa, ((BoundingCircle)entangles.get(i)).quadd);
      }
      else
        ((BoundingCircle)entangles.get(i)).Draw(entangled);
    }
    }
  }
  
  void DrawSaucers(Camera3D cameraa)
  {
    for (int i = 0; i < saucers.size(); i++)
      {
       if (!ShouldDraw(((Saucer)saucers.get(i)).quadd.points[0].x, ((Saucer)saucers.get(i)).quadd.points[2].x, cameraa))
      {
        SetQuadX(cameraa, ((Saucer)saucers.get(i)).quadd);
      }
      else
        ((Saucer)saucers.get(i)).Draw(saucerImg);
      }
  }
  
  void DrawStar(Camera3D cameraa)
  {
    if (!ShouldDraw( star.quadd.points[0].x, star.quadd.points[2].x, cameraa) )
        SetQuadX(cameraa, star.quadd);
    //else
        star.Draw();
  }
  void SetQuadX(Camera3D cameraa, Quad2D iQuad)
  {
    if (cameraa.pos.x < iQuad.center.x)
    {  
      if (Math.abs(iQuad.center.x - cameraa.pos.x) > (worldWidth - Math.abs(iQuad.center.x - cameraa.pos.x)))
             TranslateQuadX(iQuad, -worldWidth );
    }
    else 
    { 
      if (Math.abs(cameraa.pos.x - iQuad.center.x) > (worldWidth - Math.abs(cameraa.pos.x - iQuad.center.x)))
              TranslateQuadX(iQuad, worldWidth );
    }
  }
  void TranslateQuadX(Quad2D iQuad, float changeX)
  {
     iQuad.points[0].x += changeX;
     iQuad.points[1].x += changeX;
     iQuad.points[2].x += changeX;
     iQuad.points[3].x += changeX;
     
     iQuad.center.x += changeX;
  }
   void TranslatePointX(PVector ivec, float changeX)
  {
     ivec.x += changeX;
  }
  
  void SetObjects()
  {
  }
  boolean ShouldDraw(float minA, float maxA, Camera3D cameraa)
  {
    if (cameraa.pos.x- (cameraa.cwidth) > maxA)
        return false;
      if (minA > cameraa.pos.x + (cameraa.cwidth))
        return false;
       
       return true;
  }
  boolean LinearColl(float minA, float maxA,float minB, float maxB)
  {
      if (minA > maxB)
        return false;
      if (minB > maxA)
        return false;
       
       return true;
  }
  
  void PrintVector(PVector vec)
  {
    System.out.println("vec x y z: " + vec.x + " " + vec.y + " " + vec.z  );
  }
  

}







